Index: trunk/src/recompiler_new/target-i386/translate.c
===================================================================
--- trunk/src/recompiler_new/target-i386/translate.c	(revision 13672)
+++ trunk/src/recompiler_new/target-i386/translate.c	(revision 13839)
@@ -519,5 +519,5 @@
 }
 #endif
-    
+
 static void gen_add_A0_im(DisasContext *s, int val)
 {
@@ -624,5 +624,5 @@
 {
     tcg_gen_ld_tl(cpu_tmp0, cpu_env, offsetof(CPUState, regs[reg]));
-    if (shift != 0) 
+    if (shift != 0)
         tcg_gen_shli_tl(cpu_tmp0, cpu_tmp0, shift);
     tcg_gen_add_tl(cpu_A0, cpu_A0, cpu_tmp0);
@@ -690,5 +690,5 @@
 {
     tcg_gen_ld_tl(cpu_tmp0, cpu_env, offsetof(CPUState, regs[reg]));
-    if (shift != 0) 
+    if (shift != 0)
         tcg_gen_shli_tl(cpu_tmp0, cpu_tmp0, shift);
     tcg_gen_add_tl(cpu_A0, cpu_A0, cpu_tmp0);
@@ -826,12 +826,12 @@
     int skip_label;
     TCGv t0;
-    
+
     skip_label = gen_new_label();
     /* t0 = tcg_temp_local_new(TCG_TYPE_TL); */
-    t0 = cpu_tmp0; 
+    t0 = cpu_tmp0;
 
     tcg_gen_ld32u_tl(t0, cpu_env, offsetof(CPUState, interrupt_request));
     /* Keep in sync with helper_check_external_event() */
-    tcg_gen_andi_tl(t0, t0, 
+    tcg_gen_andi_tl(t0, t0,
                     CPU_INTERRUPT_EXTERNAL_EXIT
                     | CPU_INTERRUPT_EXTERNAL_TIMER
@@ -923,7 +923,7 @@
 
 #ifndef VBOX
-static inline void gen_op_movl_T0_Dshift(int ot) 
+static inline void gen_op_movl_T0_Dshift(int ot)
 #else /* VBOX */
-DECLINLINE(void) gen_op_movl_T0_Dshift(int ot) 
+DECLINLINE(void) gen_op_movl_T0_Dshift(int ot)
 #endif /* VBOX */
 {
@@ -1109,16 +1109,16 @@
 #if TCG_TARGET_REG_BITS == 32
     tcg_gen_shli_i32(cpu_tmp2_i32, cpu_cc_op, 3);
-    tcg_gen_addi_i32(cpu_tmp2_i32, cpu_tmp2_i32, 
+    tcg_gen_addi_i32(cpu_tmp2_i32, cpu_tmp2_i32,
                      (long)cc_table + offsetof(CCTable, compute_c));
     tcg_gen_ld_i32(cpu_tmp2_i32, cpu_tmp2_i32, 0);
-    tcg_gen_call(&tcg_ctx, cpu_tmp2_i32, TCG_CALL_PURE, 
+    tcg_gen_call(&tcg_ctx, cpu_tmp2_i32, TCG_CALL_PURE,
                  1, &cpu_tmp2_i32, 0, NULL);
 #else
     tcg_gen_extu_i32_tl(cpu_tmp1_i64, cpu_cc_op);
     tcg_gen_shli_i64(cpu_tmp1_i64, cpu_tmp1_i64, 4);
-    tcg_gen_addi_i64(cpu_tmp1_i64, cpu_tmp1_i64, 
+    tcg_gen_addi_i64(cpu_tmp1_i64, cpu_tmp1_i64,
                      (long)cc_table + offsetof(CCTable, compute_c));
     tcg_gen_ld_i64(cpu_tmp1_i64, cpu_tmp1_i64, 0);
-    tcg_gen_call(&tcg_ctx, cpu_tmp1_i64, TCG_CALL_PURE, 
+    tcg_gen_call(&tcg_ctx, cpu_tmp1_i64, TCG_CALL_PURE,
                  1, &cpu_tmp2_i32, 0, NULL);
 #endif
@@ -1131,16 +1131,16 @@
 #if TCG_TARGET_REG_BITS == 32
     tcg_gen_shli_i32(cpu_tmp2_i32, cpu_cc_op, 3);
-    tcg_gen_addi_i32(cpu_tmp2_i32, cpu_tmp2_i32, 
+    tcg_gen_addi_i32(cpu_tmp2_i32, cpu_tmp2_i32,
                      (long)cc_table + offsetof(CCTable, compute_all));
     tcg_gen_ld_i32(cpu_tmp2_i32, cpu_tmp2_i32, 0);
-    tcg_gen_call(&tcg_ctx, cpu_tmp2_i32, TCG_CALL_PURE, 
+    tcg_gen_call(&tcg_ctx, cpu_tmp2_i32, TCG_CALL_PURE,
                  1, &cpu_tmp2_i32, 0, NULL);
 #else
     tcg_gen_extu_i32_tl(cpu_tmp1_i64, cpu_cc_op);
     tcg_gen_shli_i64(cpu_tmp1_i64, cpu_tmp1_i64, 4);
-    tcg_gen_addi_i64(cpu_tmp1_i64, cpu_tmp1_i64, 
+    tcg_gen_addi_i64(cpu_tmp1_i64, cpu_tmp1_i64,
                      (long)cc_table + offsetof(CCTable, compute_all));
     tcg_gen_ld_i64(cpu_tmp1_i64, cpu_tmp1_i64, 0);
-    tcg_gen_call(&tcg_ctx, cpu_tmp1_i64, TCG_CALL_PURE, 
+    tcg_gen_call(&tcg_ctx, cpu_tmp1_i64, TCG_CALL_PURE,
                  1, &cpu_tmp2_i32, 0, NULL);
 #endif
@@ -1277,5 +1277,5 @@
     case CC_OP_SUBL:
     case CC_OP_SUBQ:
-        
+
         size = cc_op - CC_OP_SUBB;
         switch(jcc_op) {
@@ -1308,10 +1308,10 @@
             case 0:
                 tcg_gen_andi_tl(cpu_tmp0, cpu_cc_dst, 0x80);
-                tcg_gen_brcondi_tl(inv ? TCG_COND_EQ : TCG_COND_NE, cpu_tmp0, 
+                tcg_gen_brcondi_tl(inv ? TCG_COND_EQ : TCG_COND_NE, cpu_tmp0,
                                    0, l1);
                 break;
             case 1:
                 tcg_gen_andi_tl(cpu_tmp0, cpu_cc_dst, 0x8000);
-                tcg_gen_brcondi_tl(inv ? TCG_COND_EQ : TCG_COND_NE, cpu_tmp0, 
+                tcg_gen_brcondi_tl(inv ? TCG_COND_EQ : TCG_COND_NE, cpu_tmp0,
                                    0, l1);
                 break;
@@ -1319,15 +1319,15 @@
             case 2:
                 tcg_gen_andi_tl(cpu_tmp0, cpu_cc_dst, 0x80000000);
-                tcg_gen_brcondi_tl(inv ? TCG_COND_EQ : TCG_COND_NE, cpu_tmp0, 
+                tcg_gen_brcondi_tl(inv ? TCG_COND_EQ : TCG_COND_NE, cpu_tmp0,
                                    0, l1);
                 break;
 #endif
             default:
-                tcg_gen_brcondi_tl(inv ? TCG_COND_GE : TCG_COND_LT, cpu_cc_dst, 
+                tcg_gen_brcondi_tl(inv ? TCG_COND_GE : TCG_COND_LT, cpu_cc_dst,
                                    0, l1);
                 break;
             }
             break;
-            
+
         case JCC_B:
             cond = inv ? TCG_COND_GEU : TCG_COND_LTU;
@@ -1361,5 +1361,5 @@
             tcg_gen_brcond_tl(cond, cpu_tmp4, t0, l1);
             break;
-            
+
         case JCC_L:
             cond = inv ? TCG_COND_GE : TCG_COND_LT;
@@ -1393,10 +1393,10 @@
             tcg_gen_brcond_tl(cond, cpu_tmp4, t0, l1);
             break;
-            
+
         default:
             goto slow_jcc;
         }
         break;
-        
+
         /* some jumps are easy to compute */
     case CC_OP_ADDB:
@@ -1404,35 +1404,35 @@
     case CC_OP_ADDL:
     case CC_OP_ADDQ:
-        
+
     case CC_OP_ADCB:
     case CC_OP_ADCW:
     case CC_OP_ADCL:
     case CC_OP_ADCQ:
-        
+
     case CC_OP_SBBB:
     case CC_OP_SBBW:
     case CC_OP_SBBL:
     case CC_OP_SBBQ:
-        
+
     case CC_OP_LOGICB:
     case CC_OP_LOGICW:
     case CC_OP_LOGICL:
     case CC_OP_LOGICQ:
-        
+
     case CC_OP_INCB:
     case CC_OP_INCW:
     case CC_OP_INCL:
     case CC_OP_INCQ:
-        
+
     case CC_OP_DECB:
     case CC_OP_DECW:
     case CC_OP_DECL:
     case CC_OP_DECQ:
-        
+
     case CC_OP_SHLB:
     case CC_OP_SHLW:
     case CC_OP_SHLL:
     case CC_OP_SHLQ:
-        
+
     case CC_OP_SARB:
     case CC_OP_SARW:
@@ -1453,5 +1453,5 @@
     slow_jcc:
         gen_setcc_slow_T0(s, jcc_op);
-        tcg_gen_brcondi_tl(inv ? TCG_COND_EQ : TCG_COND_NE, 
+        tcg_gen_brcondi_tl(inv ? TCG_COND_EQ : TCG_COND_NE,
                            cpu_T[0], 0, l1);
         break;
@@ -1802,5 +1802,5 @@
 }
 
-static void gen_shift_rm_T1(DisasContext *s, int ot, int op1, 
+static void gen_shift_rm_T1(DisasContext *s, int ot, int op1,
                             int is_right, int is_arith)
 {
@@ -1844,5 +1844,5 @@
     else
         gen_op_mov_reg_T0(ot, op1);
-        
+
     /* update eflags if non zero shift */
     if (s->cc_op != CC_OP_DYNAMIC)
@@ -1865,5 +1865,5 @@
     else
         tcg_gen_movi_i32(cpu_cc_op, CC_OP_SHLB + ot);
-        
+
     gen_set_label(shift_label);
     s->cc_op = CC_OP_DYNAMIC; /* cannot predict flags after */
@@ -1877,5 +1877,5 @@
 {
     int mask;
-    
+
     if (ot == OT_QUAD)
         mask = 0x3f;
@@ -1912,5 +1912,5 @@
     else
         gen_op_mov_reg_T0(ot, op1);
-        
+
     /* update eflags if non zero shift */
     if (op2 != 0) {
@@ -1937,5 +1937,5 @@
 
 /* XXX: add faster immediate case */
-static void gen_rot_rm_T1(DisasContext *s, int ot, int op1, 
+static void gen_rot_rm_T1(DisasContext *s, int ot, int op1,
                           int is_right)
 {
@@ -1971,10 +1971,10 @@
     label1 = gen_new_label();
     tcg_gen_brcondi_tl(TCG_COND_EQ, t1, 0, label1);
-    
+
     if (ot <= OT_WORD)
         tcg_gen_andi_tl(cpu_tmp0, t1, (1 << (3 + ot)) - 1);
     else
         tcg_gen_mov_tl(cpu_tmp0, t1);
-    
+
     gen_extu(ot, t0);
     tcg_gen_mov_tl(t2, t0);
@@ -2001,5 +2001,5 @@
         gen_op_mov_reg_v(ot, op1, t0);
     }
-    
+
     /* update eflags */
     if (s->cc_op != CC_OP_DYNAMIC)
@@ -2020,8 +2020,8 @@
     tcg_gen_andi_tl(t0, t0, CC_C);
     tcg_gen_or_tl(cpu_cc_src, cpu_cc_src, t0);
-    
+
     tcg_gen_discard_tl(cpu_cc_dst);
     tcg_gen_movi_i32(cpu_cc_op, CC_OP_EFLAGS);
-        
+
     gen_set_label(label2);
     s->cc_op = CC_OP_DYNAMIC; /* cannot predict flags after */
@@ -2045,5 +2045,5 @@
 
 /* XXX: add faster immediate = 1 case */
-static void gen_rotc_rm_T1(DisasContext *s, int ot, int op1, 
+static void gen_rotc_rm_T1(DisasContext *s, int ot, int op1,
                            int is_right)
 {
@@ -2058,5 +2058,5 @@
     else
         gen_op_mov_TN_reg(ot, 0, op1);
-    
+
     tcg_gen_helper_1_2(helper_rotc[ot + (is_right * 4)],
                        cpu_T[0], cpu_T[0], cpu_T[1]);
@@ -2074,5 +2074,5 @@
     tcg_gen_discard_tl(cpu_cc_dst);
     tcg_gen_movi_i32(cpu_cc_op, CC_OP_EFLAGS);
-        
+
     gen_set_label(label1);
     s->cc_op = CC_OP_DYNAMIC; /* cannot predict flags after */
@@ -2080,5 +2080,5 @@
 
 /* XXX: add faster immediate case */
-static void gen_shiftd_rm_T1_T3(DisasContext *s, int ot, int op1, 
+static void gen_shiftd_rm_T1_T3(DisasContext *s, int ot, int op1,
                                 int is_right)
 {
@@ -2114,5 +2114,5 @@
     label1 = gen_new_label();
     tcg_gen_brcondi_tl(TCG_COND_EQ, t2, 0, label1);
-    
+
     tcg_gen_addi_tl(cpu_tmp5, t2, -1);
     if (ot == OT_WORD) {
@@ -2125,5 +2125,5 @@
 
             tcg_gen_shr_tl(cpu_tmp4, t0, cpu_tmp5);
-            
+
             /* only needed if count > 16, but a test would complicate */
             tcg_gen_sub_tl(cpu_tmp5, tcg_const_tl(32), t2);
@@ -2139,5 +2139,5 @@
             tcg_gen_or_tl(t1, t1, t0);
             tcg_gen_ext32u_tl(t1, t1);
-            
+
             tcg_gen_shl_tl(cpu_tmp4, t0, cpu_tmp5);
             tcg_gen_sub_tl(cpu_tmp0, tcg_const_tl(32), cpu_tmp5);
@@ -2162,5 +2162,5 @@
             tcg_gen_shl_tl(t1, t1, cpu_tmp5);
             tcg_gen_or_tl(t0, t0, t1);
-            
+
         } else {
             if (ot == OT_LONG)
@@ -2168,5 +2168,5 @@
 
             tcg_gen_shl_tl(cpu_tmp4, t0, cpu_tmp5);
-            
+
             tcg_gen_shl_tl(t0, t0, t2);
             tcg_gen_sub_tl(cpu_tmp5, tcg_const_tl(data_bits), t2);
@@ -2184,5 +2184,5 @@
         gen_op_mov_reg_v(ot, op1, t0);
     }
-    
+
     /* update eflags */
     if (s->cc_op != CC_OP_DYNAMIC)
@@ -2632,5 +2632,5 @@
         l1 = gen_new_label();
         gen_jcc1(s, cc_op, b, l1);
-        
+
         gen_goto_tb(s, 0, next_eip);
 
@@ -2689,5 +2689,5 @@
 #endif /* VBOX */
 {
-    tcg_gen_ld32u_tl(cpu_T[0], cpu_env, 
+    tcg_gen_ld32u_tl(cpu_T[0], cpu_env,
                      offsetof(CPUX86State,segs[seg_reg].selector));
 }
@@ -2700,8 +2700,8 @@
 {
     tcg_gen_andi_tl(cpu_T[0], cpu_T[0], 0xffff);
-    tcg_gen_st32_tl(cpu_T[0], cpu_env, 
+    tcg_gen_st32_tl(cpu_T[0], cpu_env,
                     offsetof(CPUX86State,segs[seg_reg].selector));
     tcg_gen_shli_tl(cpu_T[0], cpu_T[0], 4);
-    tcg_gen_st_tl(cpu_T[0], cpu_env, 
+    tcg_gen_st_tl(cpu_T[0], cpu_env,
                   offsetof(CPUX86State,segs[seg_reg].base));
 #ifdef VBOX
@@ -2761,5 +2761,5 @@
         gen_op_set_cc_op(s->cc_op);
     gen_jmp_im(pc_start - s->cs_base);
-    tcg_gen_helper_0_2(helper_svm_check_intercept_param, 
+    tcg_gen_helper_0_2(helper_svm_check_intercept_param,
                        tcg_const_i32(type), tcg_const_i64(param));
 }
@@ -3031,6 +3031,6 @@
         gen_op_set_cc_op(s->cc_op);
     gen_jmp_im(cur_eip);
-    tcg_gen_helper_0_2(helper_raise_interrupt, 
-                       tcg_const_i32(intno), 
+    tcg_gen_helper_0_2(helper_raise_interrupt,
+                       tcg_const_i32(intno),
                        tcg_const_i32(next_eip - cur_eip));
     s->is_jmp = 3;
@@ -3558,5 +3558,5 @@
             {
                 gen_ldst_modrm(s, modrm, OT_LONG, OR_TMP0, 0);
-                tcg_gen_addi_ptr(cpu_ptr0, cpu_env, 
+                tcg_gen_addi_ptr(cpu_ptr0, cpu_env,
                                  offsetof(CPUX86State,fpregs[reg].mmx));
                 tcg_gen_helper_0_2(helper_movl_mm_T0_mmx, cpu_ptr0, cpu_T[0]);
@@ -3567,5 +3567,5 @@
             if (s->dflag == 2) {
                 gen_ldst_modrm(s, modrm, OT_QUAD, OR_TMP0, 0);
-                tcg_gen_addi_ptr(cpu_ptr0, cpu_env, 
+                tcg_gen_addi_ptr(cpu_ptr0, cpu_env,
                                  offsetof(CPUX86State,xmm_regs[reg]));
                 tcg_gen_helper_0_2(helper_movq_mm_T0_xmm, cpu_ptr0, cpu_T[0]);
@@ -3574,5 +3574,5 @@
             {
                 gen_ldst_modrm(s, modrm, OT_LONG, OR_TMP0, 0);
-                tcg_gen_addi_ptr(cpu_ptr0, cpu_env, 
+                tcg_gen_addi_ptr(cpu_ptr0, cpu_env,
                                  offsetof(CPUX86State,xmm_regs[reg]));
                 tcg_gen_trunc_tl_i32(cpu_tmp2_i32, cpu_T[0]);
@@ -3706,5 +3706,5 @@
 #ifdef TARGET_X86_64
             if (s->dflag == 2) {
-                tcg_gen_ld_i64(cpu_T[0], cpu_env, 
+                tcg_gen_ld_i64(cpu_T[0], cpu_env,
                                offsetof(CPUX86State,fpregs[reg].mmx));
                 gen_ldst_modrm(s, modrm, OT_QUAD, OR_TMP0, 1);
@@ -3712,5 +3712,5 @@
 #endif
             {
-                tcg_gen_ld32u_tl(cpu_T[0], cpu_env, 
+                tcg_gen_ld32u_tl(cpu_T[0], cpu_env,
                                  offsetof(CPUX86State,fpregs[reg].mmx.MMX_L(0)));
                 gen_ldst_modrm(s, modrm, OT_LONG, OR_TMP0, 1);
@@ -3720,5 +3720,5 @@
 #ifdef TARGET_X86_64
             if (s->dflag == 2) {
-                tcg_gen_ld_i64(cpu_T[0], cpu_env, 
+                tcg_gen_ld_i64(cpu_T[0], cpu_env,
                                offsetof(CPUX86State,xmm_regs[reg].XMM_Q(0)));
                 gen_ldst_modrm(s, modrm, OT_QUAD, OR_TMP0, 1);
@@ -3726,5 +3726,5 @@
 #endif
             {
-                tcg_gen_ld32u_tl(cpu_T[0], cpu_env, 
+                tcg_gen_ld32u_tl(cpu_T[0], cpu_env,
                                  offsetof(CPUX86State,xmm_regs[reg].XMM_L(0)));
                 gen_ldst_modrm(s, modrm, OT_LONG, OR_TMP0, 1);
@@ -3842,5 +3842,5 @@
         case 0x050: /* movmskps */
             rm = (modrm & 7) | REX_B(s);
-            tcg_gen_addi_ptr(cpu_ptr0, cpu_env, 
+            tcg_gen_addi_ptr(cpu_ptr0, cpu_env,
                              offsetof(CPUX86State,xmm_regs[rm]));
             tcg_gen_helper_1_1(helper_movmskps, cpu_tmp2_i32, cpu_ptr0);
@@ -3850,5 +3850,5 @@
         case 0x150: /* movmskpd */
             rm = (modrm & 7) | REX_B(s);
-            tcg_gen_addi_ptr(cpu_ptr0, cpu_env, 
+            tcg_gen_addi_ptr(cpu_ptr0, cpu_env,
                              offsetof(CPUX86State,xmm_regs[rm]));
             tcg_gen_helper_1_1(helper_movmskpd, cpu_tmp2_i32, cpu_ptr0);
@@ -4541,5 +4541,5 @@
     /* illegal sequence. The s->pc is past the lock prefix and that
        is sufficient for the TB, I think. */
-    Log(("illegal lock sequence %VGv (b=%#x)\n", pc_start, b));
+    Log(("illegal lock sequence %RGv (b=%#x)\n", pc_start, b));
     return true;
 }
@@ -5136,5 +5136,5 @@
                 tcg_gen_helper_0_4(helper_lcall_protected,
                                    cpu_tmp2_i32, cpu_T[1],
-                                   tcg_const_i32(dflag), 
+                                   tcg_const_i32(dflag),
                                    tcg_const_i32(s->pc - pc_start));
             } else {
@@ -5142,5 +5142,5 @@
                 tcg_gen_helper_0_4(helper_lcall_real,
                                    cpu_tmp2_i32, cpu_T[1],
-                                   tcg_const_i32(dflag), 
+                                   tcg_const_i32(dflag),
                                    tcg_const_i32(s->pc - s->cs_base));
             }
@@ -5411,5 +5411,5 @@
             tcg_gen_helper_0_1(helper_cmpxchg16b, cpu_A0);
         } else
-#endif        
+#endif
         {
             if (!(s->cpuid_features & CPUID_CX8))
@@ -5990,5 +5990,5 @@
                         break;
                     case 2:
-                        tcg_gen_qemu_ld64(cpu_tmp1_i64, cpu_A0, 
+                        tcg_gen_qemu_ld64(cpu_tmp1_i64, cpu_A0,
                                           (s->mem_index >> 2) - 1);
                         tcg_gen_helper_0_1(helper_fldl_FT0, cpu_tmp1_i64);
@@ -6029,5 +6029,5 @@
                         break;
                     case 2:
-                        tcg_gen_qemu_ld64(cpu_tmp1_i64, cpu_A0, 
+                        tcg_gen_qemu_ld64(cpu_tmp1_i64, cpu_A0,
                                           (s->mem_index >> 2) - 1);
                         tcg_gen_helper_0_1(helper_fldl_ST0, cpu_tmp1_i64);
@@ -6051,5 +6051,5 @@
                     case 2:
                         tcg_gen_helper_1_0(helper_fisttll_ST0, cpu_tmp1_i64);
-                        tcg_gen_qemu_st64(cpu_tmp1_i64, cpu_A0, 
+                        tcg_gen_qemu_st64(cpu_tmp1_i64, cpu_A0,
                                           (s->mem_index >> 2) - 1);
                         break;
@@ -6077,5 +6077,5 @@
                     case 2:
                         tcg_gen_helper_1_0(helper_fstl_ST0, cpu_tmp1_i64);
-                        tcg_gen_qemu_st64(cpu_tmp1_i64, cpu_A0, 
+                        tcg_gen_qemu_st64(cpu_tmp1_i64, cpu_A0,
                                           (s->mem_index >> 2) - 1);
                         break;
@@ -6096,5 +6096,5 @@
                     gen_op_set_cc_op(s->cc_op);
                 gen_jmp_im(pc_start - s->cs_base);
-                tcg_gen_helper_0_2(helper_fldenv, 
+                tcg_gen_helper_0_2(helper_fldenv,
                                    cpu_A0, tcg_const_i32(s->dflag));
                 break;
@@ -6162,5 +6162,5 @@
                 break;
             case 0x3d: /* fildll */
-                tcg_gen_qemu_ld64(cpu_tmp1_i64, cpu_A0, 
+                tcg_gen_qemu_ld64(cpu_tmp1_i64, cpu_A0,
                                   (s->mem_index >> 2) - 1);
                 tcg_gen_helper_0_1(helper_fildll_ST0, cpu_tmp1_i64);
@@ -6168,5 +6168,5 @@
             case 0x3f: /* fistpll */
                 tcg_gen_helper_1_0(helper_fistll_ST0, cpu_tmp1_i64);
-                tcg_gen_qemu_st64(cpu_tmp1_i64, cpu_A0, 
+                tcg_gen_qemu_st64(cpu_tmp1_i64, cpu_A0,
                                   (s->mem_index >> 2) - 1);
                 tcg_gen_helper_0_0(helper_fpop);
@@ -6556,5 +6556,5 @@
         gen_op_mov_TN_reg(OT_WORD, 0, R_EDX);
         gen_op_andl_T0_ffff();
-        gen_check_io(s, ot, pc_start - s->cs_base, 
+        gen_check_io(s, ot, pc_start - s->cs_base,
                      SVM_IOIO_TYPE_MASK | svm_is_rep(prefixes) | 4);
         if (prefixes & (PREFIX_REPZ | PREFIX_REPNZ)) {
@@ -6712,5 +6712,5 @@
             gen_jmp_im(pc_start - s->cs_base);
             tcg_gen_helper_0_2(helper_lret_protected,
-                               tcg_const_i32(s->dflag), 
+                               tcg_const_i32(s->dflag),
                                tcg_const_i32(val));
         } else {
@@ -6757,5 +6757,5 @@
             gen_jmp_im(pc_start - s->cs_base);
             tcg_gen_helper_0_2(helper_iret_protected,
-                               tcg_const_i32(s->dflag), 
+                               tcg_const_i32(s->dflag),
                                tcg_const_i32(s->pc - s->cs_base));
             s->cc_op = CC_OP_EFLAGS;
@@ -7315,5 +7315,5 @@
             TCGv tmp0;
             gen_op_mov_TN_reg(OT_LONG, 0, reg);
-            
+
             tmp0 = tcg_temp_new(TCG_TYPE_I32);
             tcg_gen_trunc_i64_i32(tmp0, cpu_T[0]);
@@ -7662,5 +7662,5 @@
                         break;
                     } else {
-                        tcg_gen_helper_0_2(helper_vmrun, 
+                        tcg_gen_helper_0_2(helper_vmrun,
                                            tcg_const_i32(s->aflag),
                                            tcg_const_i32(s->pc - pc_start));
@@ -7698,5 +7698,5 @@
                 case 4: /* STGI */
                     if ((!(s->flags & HF_SVME_MASK) &&
-                         !(s->cpuid_ext3_features & CPUID_EXT3_SKINIT)) || 
+                         !(s->cpuid_ext3_features & CPUID_EXT3_SKINIT)) ||
                         !s->pe)
                         goto illegal_op;
@@ -7719,6 +7719,6 @@
                     break;
                 case 6: /* SKINIT */
-                    if ((!(s->flags & HF_SVME_MASK) && 
-                         !(s->cpuid_ext3_features & CPUID_EXT3_SKINIT)) || 
+                    if ((!(s->flags & HF_SVME_MASK) &&
+                         !(s->cpuid_ext3_features & CPUID_EXT3_SKINIT)) ||
                         !s->pe)
                         goto illegal_op;
@@ -7966,10 +7966,10 @@
                 if (b & 2) {
                     gen_op_mov_TN_reg(ot, 0, rm);
-                    tcg_gen_helper_0_2(helper_write_crN, 
+                    tcg_gen_helper_0_2(helper_write_crN,
                                        tcg_const_i32(reg), cpu_T[0]);
                     gen_jmp_im(s->pc - s->cs_base);
                     gen_eob(s);
                 } else {
-                    tcg_gen_helper_1_1(helper_read_crN, 
+                    tcg_gen_helper_1_1(helper_read_crN,
                                        cpu_T[0], tcg_const_i32(reg));
                     gen_op_mov_reg_T0(ot, rm);
@@ -8053,5 +8053,5 @@
                 gen_op_set_cc_op(s->cc_op);
             gen_jmp_im(pc_start - s->cs_base);
-            tcg_gen_helper_0_2(helper_fxsave, 
+            tcg_gen_helper_0_2(helper_fxsave,
                                cpu_A0, tcg_const_i32((s->dflag == 2)));
             break;