Index: /trunk/src/VBox/Main/idl/VirtualBox.xidl
===================================================================
--- /trunk/src/VBox/Main/idl/VirtualBox.xidl	(revision 14082)
+++ /trunk/src/VBox/Main/idl/VirtualBox.xidl	(revision 14083)
@@ -76,5 +76,5 @@
   <!-- NS_IMPL_THREADSAFE_ISUPPORTSxx_CI macros are placed here, for convenience -->
   <cpp>
-/* currenty, nsISupportsImpl.h lacks the below-like macros */
+/* currently, nsISupportsImpl.h lacks the below-like macros */
 
 #define NS_IMPL_THREADSAFE_QUERY_INTERFACE1_CI  NS_IMPL_QUERY_INTERFACE1_CI
@@ -213,5 +213,5 @@
           For whoever decides to touch this enum: In order to keep the
           aforementioned comparisons valid, this state must immediately
-          preceed the Paused state.
+          precede the Paused state.
         </note>
       </desc>
@@ -531,5 +531,5 @@
     <const name="MemKernelNonpaged"    value="13">
       <desc>
-        Total amount of nonpaged memory used by the guest OS's kernel in megabytes.
+        Total amount of non-paged memory used by the guest OS's kernel in megabytes.
       </desc>
     </const>
@@ -1368,5 +1368,5 @@
         Note that the actual storage unit is not created by this method. In
         order to do it, and before you are able to attach the created hard disk
-        to virtual machiens, you must call one of the following methods to
+        to virtual machines, you must call one of the following methods to
         allocate a format-specific storage unit at the specified location:
         <ul>
@@ -1382,5 +1382,5 @@
         After the storage unit is successfully created, the hard disk gets
         remembered by this VirtualBox installation and will be accessible
-        trhough <link to="#getHardDisk2()"/> and <link to="#findHardDisk2()"/>
+        through <link to="#getHardDisk2()"/> and <link to="#findHardDisk2()"/>
         methods. Remembered root (base) hard disks are also returned as part of
         the <link to="#hardDisks2"/> array. See IHardDisk2 for more details.
@@ -1415,5 +1415,5 @@
         After the hard disk is successfully opened by this method, it gets
         remembered by (known to) this VirtualBox installation and will be
-        accessible trhough <link to="#getHardDisk2()"/> and
+        accessible through <link to="#getHardDisk2()"/> and
         <link to="#findHardDisk2()"/> methods. Remembered root (base) hard disks
         are also returned as part of the <link to="#hardDisks2"/> array and can
@@ -1474,11 +1474,11 @@
         disk.
 
-        For locations repesented by file names in the host's filesystem, the
+        For locations represented by file names in the host's file system, the
         requested location can be a path relative to the
         <link to="IVirtualBox::homeFolder">VirtualBox home folder</link>. If
         only a file name without any path is given, the
         <link to="ISystemProperties::defaultHardDiskFolder"> default hard disk
-        folder</link> will be prepended to the file name before seacrhing. Note
-        that on case sensitive filesystems, a case sensitive comparison is
+        folder</link> will be prepended to the file name before searching. Note
+        that on case sensitive file systems, a case sensitive comparison is
         performed, otherwise the case of symbols in the file path is ignored.
       </desc>
@@ -1498,5 +1498,5 @@
         After the image is successfully opened by this method, it gets
         remembered by (known to) this VirtualBox installation and will be
-        accessible trhough <link to="#getDVDImage()"/> and
+        accessible through <link to="#getDVDImage()"/> and
         <link to="#findDVDImage()"/> methods. Remembered images are also
         returned as part of the <link to="#DVDImages"/> array and can be mounted
@@ -1558,6 +1558,6 @@
         only a file name without any path is given, the
         <link to="ISystemProperties::defaultHardDiskFolder"> default hard disk
-        folder</link> will be prepended to the file name before seacrhing. Note
-        that on case sensitive filesystems, a case sensitive comparison is
+        folder</link> will be prepended to the file name before searching. Note
+        that on case sensitive file systems, a case sensitive comparison is
         performed, otherwise the case of symbols in the file path is ignored.
       </desc>
@@ -1577,5 +1577,5 @@
         After the image is successfully opened by this method, it gets
         remembered by (known to) this VirtualBox installation and will be
-        accessible trhough <link to="#getFloppyImage()"/> and
+        accessible through <link to="#getFloppyImage()"/> and
         <link to="#findFloppyImage()"/> methods. Remembered images are also
         returned as part of the <link to="#floppyImages"/> array and can be
@@ -1591,5 +1591,5 @@
       <param name="location" type="wstring" dir="in">
         <desc>
-          Full path to the file that contains a valid floopy image.
+          Full path to the file that contains a valid floppy image.
         </desc>
       </param>
@@ -1637,6 +1637,6 @@
         only a file name without any path is given, the
         <link to="ISystemProperties::defaultHardDiskFolder"> default hard disk
-        folder</link> will be prepended to the file name before seacrhing. Note
-        that on case sensitive filesystems, a case sensitive comparison is
+        folder</link> will be prepended to the file name before searching. Note
+        that on case sensitive file systems, a case sensitive comparison is
         performed, otherwise the case of symbols in the file path is ignored.
       </desc>
@@ -2241,5 +2241,5 @@
         <desc>
           Used to wait until the corresponding machine is actually
-          deassociated from the given session on the server.
+          dissociated from the given session on the server.
           Returned only when this session is a direct one.
         </desc>
@@ -2382,5 +2382,5 @@
       <desc>
         Get the list of the guest properties matching a set of patterns along
-        with their values, timestamps and flags and give responsibility for
+        with their values, time stamps and flags and give responsibility for
         managing properties to the console.
       </desc>
@@ -2398,5 +2398,5 @@
       <param name="timestamp" type="unsigned long long" dir="out" safearray="yes">
         <desc>
-          The timestamps of the properties returned.  The array entries match
+          The time stamps of the properties returned.  The array entries match
           the corresponding entries in the @a name array.
         </desc>
@@ -2413,5 +2413,5 @@
       <desc>
         Set the list of the guest properties matching a set of patterns along
-        with their values, timestamps and flags and return responsibility for
+        with their values, time stamps and flags and return responsibility for
         managing properties to IMachine.
       </desc>
@@ -2429,5 +2429,5 @@
       <param name="timestamp" type="unsigned long long" dir="in" safearray="yes">
         <desc>
-          The timestamps of the properties.  The array entries match
+          The time stamps of the properties.  The array entries match
           the corresponding entries in the @a name array.
         </desc>
@@ -2578,5 +2578,5 @@
 
     <attribute name="parent" type="IVirtualBox" readonly="yes">
-      <desc>Associated parent obect.</desc>
+      <desc>Associated parent object.</desc>
     </attribute>
 
@@ -2991,5 +2991,5 @@
         recorded during machine execution. The most recent log file is
         named <tt>VBox.log</tt>, the previous log file is
-        named <tt>VBox.log.1</tt> and so on (upto <tt>VBox.log.3</tt>
+        named <tt>VBox.log.1</tt> and so on (up to <tt>VBox.log.3</tt>
         in the current version).
       </desc>
@@ -3141,5 +3141,5 @@
         For the primary controller of the IDE bus, the @a device number can be
         either @c 0 or @c 1, to specify the master or the slave device,
-        respectively. For the scondary IDE controller, the device number is
+        respectively. For the secondary IDE controller, the device number is
         always @c 1 because the master device is reserved for the CD-ROM drive.
 
@@ -3161,7 +3161,7 @@
           If the hard disk is being attached indirectly, a new differencing hard
           disk will be implicitly created for it and attached instead. If the
-          changes made to the machine settings (icluding this indirect
+          changes made to the machine settings (including this indirect
           attachment) are later cancelled using <link to="#discardSettings()"/>,
-          this implicitly created diffrerencing hard disk will be implicitly
+          this implicitly created differencing hard disk will be implicitly
           deleted.
         </note>
@@ -3214,5 +3214,5 @@
 
         Detaching the hard disk from the virtual machine is deferred. This means
-        that the hard disk remains associated with the machine when this methor
+        that the hard disk remains associated with the machine when this method
         returns and gets actually de-associated only after a successful
         <link to="#saveSettings()"/> call. See <link to="IHardDisk2"/>
@@ -3688,5 +3688,5 @@
       <desc>
         Return a list of the guest properties matching a set of patterns along
-        with their values, timestamps and flags.
+        with their values, time stamps and flags.
       </desc>
       <param name="patterns" type="wstring" dir="in">
@@ -3709,5 +3709,5 @@
       <param name="timestamp" type="unsigned long long" dir="out" safearray="yes">
         <desc>
-          The timestamps of the properties returned.  The array entries match
+          The time stamps of the properties returned.  The array entries match
           the corresponding entries in the @a name array.
         </desc>
@@ -3956,5 +3956,5 @@
       </desc>
       <param name="scope" type="Scope" dir="in">
-        <desc>Sope of the notification.</desc>
+        <desc>Scope of the notification.</desc>
       </param>
     </method>
@@ -4003,5 +4003,5 @@
         to the user and take the corresponding action.
 
-        Currently, the following error identificators are known:
+        Currently, the following error identifiers are known:
         <ul>
           <li><tt>"HostMemoryLow"</tt></li>
@@ -4024,5 +4024,5 @@
       </param>
       <param name="id" type="wstring" dir="in">
-        <desc>Error identificator</desc>
+        <desc>Error identifier</desc>
       </param>
       <param name="message" type="wstring" dir="in">
@@ -4552,8 +4552,8 @@
         of the virtual machine.
 
-        After this method succeeds, the VirtualBox server reinitiates
+        After this method succeeds, the VirtualBox server re-initiates
         all USB filters as if the device were just physically attached
         to the host, but filters of this machine are ignored to avoid
-        a possible automatic reattachment.
+        a possible automatic re-attachment.
 
         <see>IUSBController::deviceFilters, USBDeviceState</see>
@@ -5282,5 +5282,5 @@
 
     <attribute name="minGuestRAM" type="unsigned long" readonly="yes">
-      <desc>Minium guest system memory in Megabytes.</desc>
+      <desc>Minimum guest system memory in Megabytes.</desc>
     </attribute>
 
@@ -5371,5 +5371,5 @@
 
         This path is used when the storage unit of a hard disk is a regular file
-        in the host's filesystem and only a file name that contains no path is
+        in the host's file system and only a file name that contains no path is
         given.
 
@@ -5460,5 +5460,5 @@
         library that is used by default for VBoxVRDP (again, see
         <link to="ISystemProperties::remoteDisplayAuthLibrary" />).
-        The format and calling convetion of authentication libraries
+        The format and calling convention of authentication libraries
         is the same for the webservice as it is for VBoxVRDP.
 
@@ -5616,5 +5616,5 @@
       </param>
       <param name="domain" type="wstring" dir="in">
-        <desc>Domain name (guest logon scheme specific), can be emtpy</desc>
+        <desc>Domain name (guest logon scheme specific), can be empty</desc>
       </param>
       <param name="allowInteractiveLogon" type="boolean" dir="in">
@@ -5854,5 +5854,5 @@
       snapshot to the top of that branch.
 
-      Existings snapshots can be discarded using
+      Existing snapshots can be discarded using
       <link to="IConsole::discardSnapshot()"/>.
 
@@ -6112,5 +6112,5 @@
       automatically remembered by the given VirtualBox installation or, in other
       words, becomes a <i>known medium</i>. Known media are stored in the media
-      registry transparently maintaned by VirtualBox and stored in settings
+      registry transparently maintained by VirtualBox and stored in settings
       files so that this registry is preserved when VirtualBox is not running.
 
@@ -6139,5 +6139,5 @@
       value of the <link to="#state"/> attribute. When the storage unit cannot
       be read (for example, because it is located on a disconnected network
-      resource, or was accidentially deleted outside VirtualBox), the medium is
+      resource, or was accidentally deleted outside VirtualBox), the medium is
       considered to be <i>inaccessible</i> which is indicated by the
       <link to="MediaState::Inaccessible"/> state. The details about the reason
@@ -6145,5 +6145,5 @@
       <link to="#lastAccessError"/> attribute.
 
-      A new accessiblity check is performed each time the <link to="#state"/>
+      A new accessibility check is performed each time the <link to="#state"/>
       attribute is read. Please note that this check may take long time (several
       seconds or even minutes, depending on the storage unit location and
@@ -6202,5 +6202,5 @@
 
         If the last known state of the medium is <link to="MediaState::Created"/>
-        and the accessibility check fails then the state wull be set to
+        and the accessibility check fails then the state would be set to
         <link to="MediaState::Inaccessible"/> and <link to="#lastAccessError"/>
         may be used to get more details about the failure. If the state of the
@@ -6222,5 +6222,5 @@
         Location of the storage unit holding media data.
 
-        The format of the loocation string is media type specific. For media
+        The format of the location string is media type specific. For media
         types that use regular files in a host's file system, the location
         string is just a full file name.
@@ -6275,10 +6275,10 @@
     <attribute name="lastAccessError" type="wstring" readonly="yes">
       <desc>
-        Text message that represents the result of the last acccessibility
+        Text message that represents the result of the last accessibility
         check.
 
         Accessibility checks are performed each time the <link to="#state"/>
         attribute is read. A @c null string is returned if the last
-        accessibility check was succeessful. A non-null string indicates a
+        accessibility check was successful. A non-null string indicates a
         failure and should normally describe a reason of the failure (for
         example, a file read error).
@@ -6310,5 +6310,5 @@
         first element in the array will always be the ID of the queried machine
         (i.e. the value equal to the @c machineId argument), followed by
-        snapshit IDs (if any).
+        snapshot IDs (if any).
 
         If the medium is not attached to the machine in the current state, then
@@ -6355,8 +6355,8 @@
 
         This method sets the media state to <link to="MediaState::LockedRead"/>
-        on success. The state proir to this call must be
+        on success. The state prior to this call must be
         <link to="MediaState::Created"/>,
         <link to="MediaState::Inaccessible"/> or
-        <link to="MediaState::LockedRead"/>. As you can see, inacessible media
+        <link to="MediaState::LockedRead"/>. As you can see, inaccessible media
         can be locked too. This is not an error; this method performs a logical
         lock that prevents modifications of this media through the VirtualBox
@@ -6414,7 +6414,7 @@
 
         This method sets the media state to <link to="MediaState::LockedWrite"/>
-        on success. The state proir to this call must be
+        on success. The state prior to this call must be
         <link to="MediaState::Created"/> or
-        <link to="MediaState::Inaccessible"/>. As you can see, inacessible media
+        <link to="MediaState::Inaccessible"/>. As you can see, inaccessible media
         can be locked too. This is not an error; this method performs a logical
         lock that prevents modifications of this media through the VirtualBox
@@ -6451,5 +6451,5 @@
         Closes this media.
 
-        The hard disk must not be attahced to any known virtual machine and must
+        The hard disk must not be attached to any known virtual machine and must
         not have any known child hard disks, otherwise the operation will fail.
 
@@ -6615,5 +6615,5 @@
 
       If the storage unit of the hard disk is a regular file in the host's
-      filesystem then the rules stated in the description of the
+      file system then the rules stated in the description of the
       <link to="IMedium::location"/> attribute apply when setting its value. In
       addition, a plain file name without any path may be given, in which case
@@ -6631,5 +6631,5 @@
       specification which only contains the path specification but not the file
       name part and ends with either a forward slash or a backslash character.
-      In response, VirtualBox will genereate a new UUID for the hard disk and
+      In response, VirtualBox will generate a new UUID for the hard disk and
       compose the file name using the following pattern:
       <pre>
@@ -6639,5 +6639,5 @@
       <tt>&lt;uuid&gt;</tt> is the newly generated UUID and <tt>&lt;ext&gt;</tt>
       is the default extension for the storage format of this hard disk. After
-      that, you may call any of the metods that create a new hard disk storage
+      that, you may call any of the methods that create a new hard disk storage
       unit and they will use the generated UUID and file name.
 
@@ -6698,5 +6698,5 @@
           <td>Immutable</td>
           <td>
-            Immutabe hard disks are always attached <b>indirectly</b> because
+            Immutable hard disks are always attached <b>indirectly</b> because
             they are designed to be non-writable. If an immutable hard disk is
             attached to a virtual machine with snapshots then a special
@@ -6752,5 +6752,5 @@
 
       When normal base or immutable hard disks are indirectly attached to a
-      virtual machine then some additionals steps are performed to make sure the
+      virtual machine then some additional steps are performed to make sure the
       virtual machine will have the most recent "view" of the hard disk being
       attached. These steps include walking through the machine's snapshots
@@ -6809,9 +6809,9 @@
       as described above, the backup copy of the current list of hard disk
       attachment is searched for descendants. This backup copy is created when
-      the hard disk configuartion is changed for the first time after the last
+      the hard disk configuration is changed for the first time after the last
       <link to="IMachine::saveSettings()"/> call and used by
       <link to="IMachine::discardSettings()"/> to undo the recent hard disk
       changes. When such a descendant is found in this backup copy, it will be
-      simply reattached back, without creating a new differencing hard disk for
+      simply re-attached back, without creating a new differencing hard disk for
       it. This optimization is necessary to make it possible to re-attach the
       base or immutable hard disk to a different bus, channel or device slot
@@ -6894,5 +6894,5 @@
 
         A hard disk is considered to be read-only when its contents cannot be
-        modified without breaking the integrity of other parties that depednd on
+        modified without breaking the integrity of other parties that depend on
         this hard disk such as its child hard disks or snapshots of virtual
         machines where this hard disk is attached to these machines. If there
@@ -6924,5 +6924,5 @@
       <desc>
         Logical size of this hard disk (in megabytes), as reported to the
-        guest OS running inside the vurtual machine this disk is
+        guest OS running inside the virtual machine this disk is
         attached to. The logical size is defined when the hard disk is created
         and cannot be changed later.
@@ -6945,5 +6945,5 @@
     <method name="createDynamicStorage">
       <desc>
-        Starts creating a dymically expanding hard disk storage unit in the
+        Starts creating a dynamically expanding hard disk storage unit in the
         background. The previous storage unit created for this this object, if
         any, must be first deleted using <link to="#deleteStorage"/>, otherwise
@@ -6997,5 +6997,5 @@
         Starts deleting the storage unit of this hard disk.
 
-        The hard disk must not be attahced to any known virtual machine and must
+        The hard disk must not be attached to any known virtual machine and must
         not have any known child hard disks, otherwise the operation will fail.
         It will also fail if there is no storage unit to delete or if deletion
@@ -7090,5 +7090,5 @@
         disk itself since it will no longer be based on any other hard disk.
 
-        Considering the above, all of the following condtions must be met in
+        Considering the above, all of the following conditions must be met in
         order for the merge operation to succeed:
         <ul>
@@ -7278,5 +7278,5 @@
         The format backend operates on files. The <link to="IMedium::location"/>
         attribute of the hard disk specifies a file used to store hard disk
-        data. For a list of supported file extentions see
+        data. For a list of supported file extensions see
         <link to="IHardDiskFormat::fileExtensions"/>.
       </desc>
@@ -7287,5 +7287,5 @@
         The format backend uses the property interface to configure the storage
         location and properties. The <link to="IHardDiskFormat::describeProperties"/>
-        method is used to get access to poperties supported by the given hard
+        method is used to get access to properties supported by the given hard
         disk format.
       </desc>
@@ -7341,5 +7341,5 @@
 
         The first extension in the array is the extension preferred by the
-        backend. It is recommended to use this extension when specifyng a
+        backend. It is recommended to use this extension when specifying a
         location of the storage unit for a new hard disk.
 
@@ -7355,5 +7355,5 @@
         Capabilities of the format as a set of bit flags.
 
-        For the meaning of individual capabilitiy flags see
+        For the meaning of individual capability flags see
         <link to="HardDiskFormatCapabilities"/>.
       </desc>
@@ -7634,5 +7634,5 @@
       <param name="dx" type="long" dir="in">
         <desc>
-          Amout of pixels the mouse should move to the right.
+          Amount of pixels the mouse should move to the right.
           Negative values move the mouse to the left.
         </desc>
@@ -7640,5 +7640,5 @@
       <param name="dy" type="long" dir="in">
         <desc>
-          Amout of pixels the mouse should move downwards.
+          Amount of pixels the mouse should move downwards.
           Negative values move the mouse upwards.
         </desc>
@@ -7693,5 +7693,5 @@
       <param name="dz" type="long" dir="in">
         <desc>
-          Amout of mouse wheel moves.
+          Amount of mouse wheel moves.
           Positive values describe clockwise wheel rotations,
           negative values describe counterclockwise rotations.
@@ -7725,5 +7725,5 @@
   >
     <desc>
-      Framebuffer acceleration operation.
+      Frame buffer acceleration operation.
     </desc>
 
@@ -7765,13 +7765,13 @@
      >
     <attribute name="address" type="octet" mod="ptr" readonly="yes">
-      <desc>Address of the start byte of the framebuffer.</desc>
+      <desc>Address of the start byte of the frame buffer.</desc>
     </attribute>
 
     <attribute name="width" type="unsigned long" readonly="yes">
-      <desc>Framebuffer width, in pixels.</desc>
+      <desc>Frame buffer width, in pixels.</desc>
     </attribute>
 
     <attribute name="height" type="unsigned long" readonly="yes">
-      <desc>Framebuffer height, in pixels.</desc>
+      <desc>Frame buffer height, in pixels.</desc>
     </attribute>
 
@@ -7794,5 +7794,5 @@
     <attribute name="pixelFormat" type="unsigned long" readonly="yes">
       <desc>
-        Framebuffer pixel format. It's either one of the values defined by <link
+        Frame buffer pixel format. It's either one of the values defined by <link
         to="FramebufferPixelFormat"/> or a raw FOURCC code.
         <note>
@@ -7806,5 +7806,5 @@
     <attribute name="usesGuestVRAM" type="boolean" readonly="yes">
       <desc>
-        Defines whether this framebuffer uses the virtual video card's memory
+        Defines whether this frame buffer uses the virtual video card's memory
         buffer (guest VRAM) directly or not. See <link
         to="IFramebuffer::requestResize()"/> for more information.
@@ -7814,5 +7814,5 @@
     <attribute name="heightReduction" type="unsigned long" readonly="yes">
       <desc>
-        Hint from the framebuffer about how much of the standard
+        Hint from the frame buffer about how much of the standard
         screen height it wants to use for itself. This information is
         exposed to the guest through the VESA BIOS and VMMDev interface
@@ -7824,5 +7824,5 @@
     <attribute name="overlay" type="IFramebufferOverlay" readonly="yes">
       <desc>
-        An alpha-blended overlay which is superposed over the framebuffer.
+        An alpha-blended overlay which is superposed over the frame buffer.
         The initial purpose is to allow the display of icons providing
         information about the VM state, including disk activity, in front
@@ -7840,5 +7840,5 @@
       <desc>
         Platform-dependent identifier of the window where context of this
-        framebuffer is drawn, or zero if there's no such window.
+        frame buffer is drawn, or zero if there's no such window.
       </desc>
     </attribute>
@@ -7846,6 +7846,6 @@
     <method name="lock">
       <desc>
-        Locks the framebuffer.
-        Gets called by the IDisplay object where this framebuffer is
+        Locks the frame buffer.
+        Gets called by the IDisplay object where this frame buffer is
         bound to.
       </desc>
@@ -7854,6 +7854,6 @@
     <method name="unlock">
       <desc>
-        Unlocks the framebuffer.
-        Gets called by the IDisplay object where this framebuffer is
+        Unlocks the frame buffer.
+        Gets called by the IDisplay object where this frame buffer is
         bound to.
       </desc>
@@ -7912,5 +7912,5 @@
         bitsPerPixel and @a bytesPerLine define the format of the video memory
         buffer pointed to by the @a VRAM parameter and the implementation is
-        free to choose which mode to use. To indicate that this framebuffer uses
+        free to choose which mode to use. To indicate that this frame buffer uses
         the direct mode, the implementation of the <link to="#usesGuestVRAM"/>
         attribute must return <tt>true</tt> and <link to="#address"/> must
@@ -7924,20 +7924,20 @@
         display mode. In case of direct mode, it is guaranteed that the given @a
         VRAM buffer contains enough space to represent the display mode of the
-        given size. Note that this framebuffer's <link to="#width"/> and <link
+        given size. Note that this frame buffer's <link to="#width"/> and <link
         to="#height"/> attributes must return exactly the same values as
         passed to this method after the resize is completed (see below).
 
         The @a finished output parameter determines if the implementation has
-        finished resizing the framebuffer or not. If, for some reason, the
+        finished resizing the frame buffer or not. If, for some reason, the
         resize cannot be finished immediately during this call, @a finished
         must be set to @c false, and the implementation must call
         <link to="IDisplay::resizeCompleted()"/> after it has returned from
         this method as soon as possible. If @a finished is @c false, the
-        machine will not call any framebuffer methods until
+        machine will not call any frame buffer methods until
         <link to="IDisplay::resizeCompleted()"/> is called.
 
         Note that if the direct mode is chosen, the <link to="#bitsPerPixel"/>,
         <link to="#bytesPerLine"/> and <link to="#pixelFormat"/> attributes of
-        this framebuffer must return exactly the same values as specified in the
+        this frame buffer must return exactly the same values as specified in the
         parameters of this method, after the resize is completed. If the
         indirect mode is chosen, these attributes must return values describing
@@ -7985,5 +7985,5 @@
       <param name="finished" type="boolean" dir="return">
         <desc>
-          Can the VM start using the new framebuffer immediately
+          Can the VM start using the new frame buffer immediately
           after this method returns or it should wait for
           <link to="IDisplay::resizeCompleted()"/>.
@@ -8010,5 +8010,5 @@
     <method name="videoModeSupported">
       <desc>
-        Returns whether the framebuffer implementation is willing to
+        Returns whether the frame buffer implementation is willing to
         support a given video mode. In case it is not able to render
         the video mode (or for some reason not willing), it should
@@ -8051,5 +8051,5 @@
     <method name="getVisibleRegion">
       <desc>
-        Returns the visible region of this framebuffer.
+        Returns the visible region of this frame buffer.
 
         If the @a rectangles parameter is <tt>NULL</tt> then the value of the
@@ -8081,5 +8081,5 @@
     <method name="setVisibleRegion">
       <desc>
-        Suggests a new visible region to this framebuffer.  This region
+        Suggests a new visible region to this frame buffer.  This region
         represents the area of the VM display which is a union of regions of
         all top-level windows of the guest operating system running inside the
@@ -8123,9 +8123,9 @@
     </desc>
     <attribute name="x" type="unsigned long" readonly="yes">
-      <desc>X position of the overlay, relative to the framebuffer.</desc>
+      <desc>X position of the overlay, relative to the frame buffer.</desc>
     </attribute>
 
     <attribute name="y" type="unsigned long" readonly="yes">
-      <desc>Y position of the overlay, relative to the framebuffer.</desc>
+      <desc>Y position of the overlay, relative to the frame buffer.</desc>
     </attribute>
 
@@ -8186,5 +8186,5 @@
     <method name="setupInternalFramebuffer">
       <desc>
-        Prepares an internally managed framebuffer.
+        Prepares an internally managed frame buffer.
       </desc>
       <param name="depth" type="unsigned long" dir="in"/>
@@ -8193,5 +8193,5 @@
     <method name="lockFramebuffer">
       <desc>
-        Requests access to the internal framebuffer.
+        Requests access to the internal frame buffer.
       </desc>
       <param name="address" type="octet" mod="ptr" dir="return"/>
@@ -8200,5 +8200,5 @@
     <method name="unlockFramebuffer">
       <desc>
-        Releases access to the internal framebuffer.
+        Releases access to the internal frame buffer.
       </desc>
     </method>
@@ -8206,5 +8206,5 @@
     <method name="registerExternalFramebuffer">
       <desc>
-        Registers an external framebuffer.
+        Registers an external frame buffer.
       </desc>
       <param name="framebuffer" type="IFramebuffer" dir="in"/>
@@ -9010,5 +9010,5 @@
       <desc>
         Host USB port number the device is physically
-        coonected to.
+        connected to.
       </desc>
     </attribute>
@@ -9103,5 +9103,5 @@
         </li>
         <li><i>Exact match</i>. Used to specify a single value for the given
-          device attribute. Any string that does't start with <tt>int:</tt>
+          device attribute. Any string that doesn't start with <tt>int:</tt>
           represents the exact match. String device attributes are compared to
           this string including case of symbols. Integer attributes are first
@@ -9210,5 +9210,5 @@
       <desc>
        This is an advanced option for hiding one or more USB interfaces
-       from the guest. The value is a bitmask where the bits that are set
+       from the guest. The value is a bit mask where the bits that are set
        means the corresponding USB interface should be hidden, masked off
        if you like.
@@ -9237,5 +9237,5 @@
       Once a supported USB device is attached to the host, global USB
       filters (<link to="IHost::USBDeviceFilters"/>) are activated. They can
-      either ignore the device, or put ot to #Held state, or do nothing. Unless
+      either ignore the device, or put it to #Held state, or do nothing. Unless
       the device is ignored by global filters, filters of all currently running
       guests (<link to="IUSBController::deviceFilters"/>) are activated that can
@@ -9784,5 +9784,5 @@
     <method name="onSerialPortChange">
       <desc>
-        Triggered when settions of a serial port of the
+        Triggered when settings of a serial port of the
         associated virtual machine have changed.
       </desc>
@@ -9881,5 +9881,5 @@
       <desc>
         Return a list of the guest properties matching a set of patterns along
-        with their values, timestamps and flags.
+        with their values, time stamps and flags.
       </desc>
       <param name="patterns" type="wstring" dir="in">
@@ -9903,5 +9903,5 @@
       <param name="timestamp" type="unsigned long long" dir="out" safearray="yes">
         <desc>
-          The timestamps of the properties returned.  The array entries match
+          The time stamps of the properties returned.  The array entries match
           the corresponding entries in the @a key array.
         </desc>
@@ -10315,5 +10315,5 @@
       <ul>
         <li>
-          Obtain an instance of IPerfromanceCollector with
+          Obtain an instance of IPerformanceCollector with
           <link to="IVirtualBox::performanceCollector" />
         </li>